; Compiled with: PIC18 Simulator IDE v2.76
; Microcontroller model: PIC18F2550
; Clock frequency: 20.0 MHz
;
;       The address of 'data' (array 7) (byte) (global) is 0x044
	data EQU 0x044
;       The address of 'i' (byte) (global) is 0x04B
	i EQU 0x04B
; Begin
	R0L EQU 0x000
	R0H EQU 0x001
	R1L EQU 0x002
	R1H EQU 0x003
	R2L EQU 0x004
	R2H EQU 0x005
	R3L EQU 0x006
	R3H EQU 0x007
	R4L EQU 0x008
	R4H EQU 0x009
	R5L EQU 0x00A
	R5H EQU 0x00B
	R6L EQU 0x00C
	R6H EQU 0x00D
	R7L EQU 0x00E
	R7H EQU 0x00F
	R8L EQU 0x010
	R8H EQU 0x011
	R9L EQU 0x012
	R9H EQU 0x013
	ORG 0x000000
	BSF RCON,IPEN
	GOTO L0011
	ORG 0x000008
	RETFIE FAST
	ORG 0x000018
	RETFIE FAST
	ORG 0x000030
	CALL L0002
	RETURN
	ORG 0x000038
	CALL L0003
	RETURN
	ORG 0x000040
	CALL L0004
	RETURN
	ORG 0x000048
	CALL L0005
	RETURN
	ORG 0x001000
; Begin of program
L0011:
; 1: UsbSetVendorId 0x1111
; 2: UsbSetProductId 0x1111
; 3: UsbSetVersionNumber 0x1111
; 4: UsbSetManufacturerString "Robot USB"
; 5: UsbSetProductString "RUSB-1 "
; 6: UsbSetSerialNumberString "1111111111"
; 7: UsbOnIoInGosub usbonioin
; 8: UsbOnIoOutGosub usbonioout
; 9: UsbOnFtInGosub usbonftin
; 10: UsbOnFtOutGosub usbonftout
; 11: 
; 12: TRISB = %00000000
	CLRF 0xF93
; 13: 
; 14: UsbStart
	CALL 0x00006E
; 15: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 16: 
; 17: Dim data(7) As Byte
; 18: Dim i As Byte
; 19: 
; 20: loop:
L0001:
; 21: 	PORTB = %00000000
	CLRF 0xF81
; 22: 	UsbIoBuffer(7) = 0
	CLRF 0x01B
; 23: 	UsbService
	CALL 0x0000D4
; 24: 	data(7) = UsbIoBuffer(7)
	MOVF 0x01B,W
	MOVWF 0x04B
; 25: 	If data(7) = 10 Then Gosub avanza
	MOVF 0x04B,W
	SUBLW 0x0A
	BTFSS STATUS,Z
	GOTO L0012
	CALL L0006
L0012:
; 26: 	If data(7) = 20 Then Gosub back
	MOVF 0x04B,W
	SUBLW 0x14
	BTFSS STATUS,Z
	GOTO L0013
	CALL L0007
L0013:
; 27: 	If data(7) = 30 Then Gosub g_der
	MOVF 0x04B,W
	SUBLW 0x1E
	BTFSS STATUS,Z
	GOTO L0014
	CALL L0008
L0014:
; 28: 	If data(7) = 40 Then Gosub g_izq
	MOVF 0x04B,W
	SUBLW 0x28
	BTFSS STATUS,Z
	GOTO L0015
	CALL L0009
L0015:
; 29: 	If data(7) = 5 Then Gosub apago
	MOVF 0x04B,W
	SUBLW 0x05
	BTFSS STATUS,Z
	GOTO L0016
	CALL L0010
L0016:
; 30: 	WaitMs 10
	MOVLW 0x0A
	MOVWF R0L
	CLRF R0H
	CALL W001
; 31: 	Goto loop
	GOTO L0001
; 32: End
L0017:	BRA L0017
; 33: 
; 34: usbonftout:
L0002:
; 35: Return
	RETURN
; 36: 
; 37: usbonftin:
L0003:
; 38: Return
	RETURN
; 39: 
; 40: usbonioout:
L0004:
; 41: Return
	RETURN
; 42: 
; 43: usbonioin:
L0005:
; 44: Return
	RETURN
; 45: 
; 46: 
; 47: avanza:
L0006:
; 48: 	For i = 1 To 3
	MOVLW 0x01
	MOVWF 0x04B
L0018:
	MOVF 0x04B,W
	SUBLW 0x03
	BTFSS STATUS,C
	GOTO L0019
; 49: 		PORTB.7 = 1
	BSF 0xF81,7
; 50: 		WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 51: 		PORTB.7 = 0
	BCF 0xF81,7
; 52: 		WaitMs 19
	MOVLW 0x13
	MOVWF R0L
	CLRF R0H
	CALL W001
; 53: 		PORTB.6 = 1
	BSF 0xF81,6
; 54: 		WaitMs 2
	MOVLW 0x02
	MOVWF R0L
	CLRF R0H
	CALL W001
; 55: 		PORTB.6 = 0
	BCF 0xF81,6
; 56: 		WaitMs 18
	MOVLW 0x12
	MOVWF R0L
	CLRF R0H
	CALL W001
; 57: 	Next i
	MOVLW 0x01
	ADDWF 0x04B,F
	BTFSS STATUS,C
	GOTO L0018
L0019:
; 58: Return
	RETURN
; 59: 
; 60: 
; 61: back:
L0007:
; 62: 	For i = 1 To 3
	MOVLW 0x01
	MOVWF 0x04B
L0020:
	MOVF 0x04B,W
	SUBLW 0x03
	BTFSS STATUS,C
	GOTO L0021
; 63: 		PORTB.7 = 1
	BSF 0xF81,7
; 64: 		WaitMs 2
	MOVLW 0x02
	MOVWF R0L
	CLRF R0H
	CALL W001
; 65: 		PORTB.7 = 0
	BCF 0xF81,7
; 66: 		WaitMs 18
	MOVLW 0x12
	MOVWF R0L
	CLRF R0H
	CALL W001
; 67: 		PORTB.6 = 1
	BSF 0xF81,6
; 68: 		WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 69: 		PORTB.6 = 0
	BCF 0xF81,6
; 70: 		WaitMs 19
	MOVLW 0x13
	MOVWF R0L
	CLRF R0H
	CALL W001
; 71: 	Next i
	MOVLW 0x01
	ADDWF 0x04B,F
	BTFSS STATUS,C
	GOTO L0020
L0021:
; 72: 
; 73: Return
	RETURN
; 74: 
; 75: g_der:
L0008:
; 76: 	For i = 1 To 3
	MOVLW 0x01
	MOVWF 0x04B
L0022:
	MOVF 0x04B,W
	SUBLW 0x03
	BTFSS STATUS,C
	GOTO L0023
; 77: 		PORTB.7 = 1
	BSF 0xF81,7
; 78: 		PORTB.6 = 1
	BSF 0xF81,6
; 79: 		WaitMs 1
	MOVLW 0x01
	MOVWF R0L
	CLRF R0H
	CALL W001
; 80: 		PORTB.7 = 0
	BCF 0xF81,7
; 81: 		PORTB.6 = 0
	BCF 0xF81,6
; 82: 		WaitMs 19
	MOVLW 0x13
	MOVWF R0L
	CLRF R0H
	CALL W001
; 83: 	Next i
	MOVLW 0x01
	ADDWF 0x04B,F
	BTFSS STATUS,C
	GOTO L0022
L0023:
; 84: Return
	RETURN
; 85: 
; 86: g_izq:
L0009:
; 87: 	For i = 1 To 3
	MOVLW 0x01
	MOVWF 0x04B
L0024:
	MOVF 0x04B,W
	SUBLW 0x03
	BTFSS STATUS,C
	GOTO L0025
; 88: 		PORTB.7 = 1
	BSF 0xF81,7
; 89: 		PORTB.6 = 1
	BSF 0xF81,6
; 90: 		WaitMs 2
	MOVLW 0x02
	MOVWF R0L
	CLRF R0H
	CALL W001
; 91: 		PORTB.7 = 0
	BCF 0xF81,7
; 92: 		PORTB.6 = 0
	BCF 0xF81,6
; 93: 		WaitMs 18
	MOVLW 0x12
	MOVWF R0L
	CLRF R0H
	CALL W001
; 94: 	Next i
	MOVLW 0x01
	ADDWF 0x04B,F
	BTFSS STATUS,C
	GOTO L0024
L0025:
; 95: Return
	RETURN
; 96: 
; 97: apago:
L0010:
; 98: 	PORTB.7 = 0
	BCF 0xF81,7
; 99: 	PORTB.6 = 0
	BCF 0xF81,6
; 100: 	UsbStop
	CALL 0x0000CE
; 101: 	WaitMs 3000
	MOVLW 0xB8
	MOVWF R0L
	MOVLW 0x0B
	MOVWF R0H
	CALL W001
; End of program
L0026:	BRA L0026
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	BRA W002
	RCALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	BRA W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	RCALL W003
	DECF R0H,F
	DECF R0L,F
	BRA W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	BRA W004
	NOP
	NOP
	MOVLW 0x62
	MOVWF R1L
W005:	DECFSZ R1L,F
	BRA W006
	RCALL W007
	RCALL W007
	NOP
	NOP
	RETURN
W006:	RCALL W007
	BRA W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	BRA W008
	NOP
	RETURN
; End of listing
	END
